> module Main where
>
> import Parsing
> import Parsec
> import Printing
> import qualified Walk as W
> import qualified Merge as M
> import Abstract
> import IO

> main = do file <- hGetContents stdin
>           compile file

> compile file = 
>        do let pfs = fromEither $ parse document "" file
>           let cfs = map W.dowalk pfs
>           putStr $ show $ Tag [] (M.plintroL W.init_ctx $ M.mergeL W.init_ctx [] cfs)

> fromEither (Left e)  = error $ show e
> fromEither (Right r) = r
