> module Printing where

> import Abstract

> instance Show SMLNG where
>   showsPrec _ (Tag ts bds)   = let s = map shows ts
>                                in  compMap make_open_tag s 
>                                  . compMap shows bds
>                                  . compMap make_close_tag (reverse s)
>   showsPrec _ (Text s)       = showString s

> compMap                      :: (a -> (b -> b)) -> [a] -> b -> b
> compMap f                    = foldr (.) id . map f

> make_open_tag,make_close_tag :: ShowS -> ShowS
> make_open_tag t              = showString "<" . t . showString ">"
> make_close_tag t             = showString "</" . t . showString ">"

> instance Show Tag where
>   showsPrec _ TB             = showString "B"
>   showsPrec _ TEM            = showString "EM"
>   showsPrec _ TI             = showString "I"
>   showsPrec _ TPL            = showString "PL"
>   showsPrec _ TS             = showString "S"
>   showsPrec _ TTT            = showString "TT"
>   showsPrec _ TU             = showString "U"
>   showsPrec _ (Tsize n)      = shows n
>   showsPrec _ (Tcolor c)     = shows c

> instance Show Color where
>   showsPrec _ Cr             = showString "r"
>   showsPrec _ Cg             = showString "g"
>   showsPrec _ Cb             = showString "b"
>   showsPrec _ Cc             = showString "c"
>   showsPrec _ Cm             = showString "m"
>   showsPrec _ Cy             = showString "y"
>   showsPrec _ Ck             = showString "k"
>   showsPrec _ Cw             = showString "w"
